unit TrackRuntime;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, VWTrackMouse, MyComponent;

type
  TForm1 = class(TForm)
    pnlWarning: TPanel;
    pnlMenu: TPanel;
    pnlDestroy: TPanel;
    pnlRemoveAll: TPanel;
    pnlRemove: TPanel;
    pnlRun: TPanel;
    pnlAdd: TPanel;
    Edit1: TEdit;
    Button2: TButton;
    Label1: TLabel;
    pnlImage: TPanel;
    imgTrack: TImage;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Timer1: TTimer;
    Label2: TLabel;
    procedure VWTrackMouseEnter(Sender: TObject);
    procedure VWTrackMouseLeave(Sender: TObject);
    procedure pnlRunClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure pnlAddClick(Sender: TObject);
    procedure pnlRemoveClick(Sender: TObject);
    procedure pnlRemoveAllClick(Sender: TObject);
    procedure pnlDestroyClick(Sender: TObject);
  private
  public
        VWTrack : TVWTrackMouse;
        VWProp  : TVWControlsListProperty;
        VWList  : TVWControlsList;
        constructor Create( Owner : TComponent ); override;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

constructor TForm1.Create( Owner : TComponent ); 
begin
     inherited Create(Owner);
     VWTrack := TVWTrackMouse.Create(self);
     VWTrack.Bounding := false;
     VWTrack.OnMouseEnter := VWTrackMouseEnter;
     VWTrack.OnMouseLeave := VWTrackMouseLeave;
     // Add the menu panels.
     VWTrack.Controls.Add( pnlAdd );
     VWTrack.Controls.Add( pnlRun );
     VWTrack.Controls.Add( pnlRemove );
     VWTrack.Controls.Add( pnlRemoveAll );
     VWTrack.Controls.Add( pnlDestroy );
     Timer1.Enabled := true;
     // Set BevelOuter of Panels to bvNone
     Panel1.BevelOuter := bvNone;
     Panel2.BevelOuter := bvNone;
     Panel3.BevelOuter := bvNone;
     Panel4.BevelOuter := bvNone;
     Panel5.BevelOuter := bvNone;
     Tag := 0;
end;

procedure TForm1.VWTrackMouseEnter(Sender: TObject);
var Rect : TRect;
begin
     // You can use IsClass or...
     if IsClass(Sender.ClassType, 'TPanel') then begin
        if TPanel(Sender).Name = 'pnlImage' then begin
           imgTrack.Picture.LoadFromFile('c:\projects\track\delphi\VWTrackMouse.bmp');
           TPanel(Sender).Color := $414141;
           TPanel(Sender).BevelOuter := bvRaised;
        end
        else begin
            if TPanel(Sender).Enabled then
               TPanel(Sender).Color := $414141
            else
               TPanel(Sender).Color := clSilver;
            TPanel(Sender).Cursor := crHandPoint;
        end;
     end
     // ... use this way. You're the who knows.
     else if (TControl(Sender).ClassName = 'TEdit')
     or  (TControl(Sender).ClassName = 'TLabel')
     or  (TControl(Sender).ClassName = 'TButton')
     then begin
        Rect.Left   := TEdit(Sender).Left-2;
        Rect.Top    := TEdit(Sender).Top-2;
        Rect.Right  := TEdit(Sender).Left + TEdit(Sender).Width + 2;
        Rect.Bottom := TEdit(Sender).Top + TEdit(Sender).Height + 2;
        Canvas.Brush.Color := clBlue;
        Canvas.FrameRect( Rect );
     end;
end;

procedure TForm1.VWTrackMouseLeave(Sender: TObject);
var Rect : TRect;
begin
     // You can use IsClass or...
     if IsClass(Sender.ClassType, 'TPanel') then begin
        if TPanel(Sender).Name = 'pnlImage' then begin
           imgTrack.Picture.LoadFromFile('c:\projects\track\delphi\VWTrackMouse2.bmp');
           TPanel(Sender).Color := clGray;
           TPanel(Sender).BevelOuter := bvNone;
        end
        else begin
            if TPanel(Sender).Enabled then
               TPanel(Sender).Color := clGray
            else
               TPanel(Sender).Color := clSilver;
            TPanel(Sender).Cursor := crDefault;
        end;
     end
     // ... use this way. You're the who knows.
     else if (TControl(Sender).ClassName = 'TEdit')
     or  (TControl(Sender).ClassName = 'TLabel')
     or  (TControl(Sender).ClassName = 'TButton')
     then begin
        Rect.Left   := TEdit(Sender).Left-2;
        Rect.Top    := TEdit(Sender).Top-2;
        Rect.Right  := TEdit(Sender).Left + TEdit(Sender).Width + 2;
        Rect.Bottom := TEdit(Sender).Top + TEdit(Sender).Height + 2;
        Canvas.Brush.Color := clSilver;
        Canvas.FrameRect( Rect );
     end;
end;

procedure TForm1.pnlRunClick(Sender: TObject);
begin
     VWTrack.Run;
     Timer1.Enabled := false;
     pnlRun.Font.Color := clWhite;
     pnlRun.Caption := 'Run VWTrackMouse ';
     // Enable the panels
     pnlAdd.Enabled := true;
     pnlRemove.Enabled := true;
     pnlRemoveAll.Enabled := true;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     if Timer1.Tag = 0 then begin
        pnlRun.Color := clAqua;
        pnlRun.Font.Color := clBlack;
        pnlRun.Caption := 'Click me ';
        Timer1.Tag := 1;
     end
     else begin
        pnlRun.Color := clGray;
        pnlRun.Font.Color := clWhite;
        pnlRun.Caption := 'Run VWTrackMouse ';
        Timer1.Tag := 0;
     end;
end;

procedure TForm1.pnlAddClick(Sender: TObject);
begin
     VWTrack.Controls.Add( Edit1 );
     VWTrack.Controls.Add( Button2 );
     VWTrack.Controls.Add( Label1 );
     VWTrack.Controls.Add( pnlImage );
     VWTrack.Controls.Add( Panel1 );
     VWTrack.Controls.Add( Panel2 );
     VWTrack.Controls.Add( Panel3 );
     VWTrack.Controls.Add( Panel4 );
     VWTrack.Controls.Add( Panel5 );
     pnlAdd.Enabled := false;
     pnlRemoveAll.Enabled := true;
end;

procedure TForm1.pnlRemoveClick(Sender: TObject);
begin
     if VWTrack.Controls.Remove( pnlImage ) = -1 then
        MessageBox( 0, PChar('The control ''pnlImage'' have been removed.'), PChar('Error'), (MB_ICONERROR or MB_OK) );
end;

procedure TForm1.pnlRemoveAllClick(Sender: TObject);
begin
     VWTrack.Controls.Remove( Edit1 );
     VWTrack.Controls.Remove( Button2 );
     VWTrack.Controls.Remove( Label1 );
     VWTrack.Controls.Remove( pnlImage );
     VWTrack.Controls.Remove( Panel1 );
     VWTrack.Controls.Remove( Panel2 );
     VWTrack.Controls.Remove( Panel3 );
     VWTrack.Controls.Remove( Panel4 );
     VWTrack.Controls.Remove( Panel5 );
     pnlAdd.Enabled := true;
     pnlRemoveAll.Enabled := false;
end;

procedure TForm1.pnlDestroyClick(Sender: TObject);
begin
     VWTrack.Destroy;
     Close;
end;

end.
